diff -ruN vdr-2.2.0/PLUGINS/src/osddemo/osddemo.c vdr-2.3.1/PLUGINS/src/osddemo/osddemo.c
--- vdr-2.2.0/PLUGINS/src/osddemo/osddemo.c	2015-02-17 14:12:36.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/osddemo/osddemo.c	2015-04-12 11:35:21.000000000 +0200
@@ -3,13 +3,13 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: osddemo.c 3.4 2015/02/17 13:12:36 kls Exp $
+ * $Id: osddemo.c 4.3 2015/04/12 09:35:21 kls Exp $
  */
 
 #include <vdr/osd.h>
 #include <vdr/plugin.h>
 
-static const char *VERSION        = "2.2.0";
+static const char *VERSION        = "2.3.1";
 static const char *DESCRIPTION    = "Demo of arbitrary OSD setup";
 static const char *MAINMENUENTRY  = "Osd Demo";
 
@@ -90,6 +90,52 @@
   Osd->Flush();
 }
 
+// --- DrawImages ------------------------------------------------------------
+
+struct tOsdImageRef {
+  int image;
+  cSize size;
+  };
+
+#define NUMOSDIMAGES 16
+#define NUMOSDIMAGEVARIANTS 8
+
+void DrawImages(cOsd *Osd)
+{
+  // Create images:
+  cImage *images[NUMOSDIMAGEVARIANTS];
+  for (int i = 0; i < NUMOSDIMAGEVARIANTS; i++) {
+      images[i] = new cImage(cSize(
+        i == 0 || i == 1 ? Osd->MaxPixmapSize().Width() + 1 : rand() % Osd->Width(),
+        i == 0 || i == 2 ? Osd->MaxPixmapSize().Height() + 1 : rand() % Osd->Height()));
+      for (int x = 0; x < images[i]->Width(); x++) {
+          for (int y = 0; y < images[i]->Height(); y++) {
+              images[i]->SetPixel(cPoint(x, y),
+                (!x || !y || x == images[i]->Width() - 1 || y == images[i]->Height() - 1) ? clrWhite :
+                (x > images[i]->Width() / 2 ?
+                  (y > images[i]->Height() / 2 ? clrBlue : clrGreen) :
+                  (y > images[i]->Height() / 2 ? clrRed : clrYellow)));
+              }
+          }
+      }
+  // Store images:
+  tOsdImageRef osdImages[NUMOSDIMAGES];
+  for (int i = 0; i < NUMOSDIMAGES; i++) {
+      osdImages[i].image = cOsdProvider::StoreImage(*images[i % NUMOSDIMAGEVARIANTS]);
+      osdImages[i].size.Set(images[i % NUMOSDIMAGEVARIANTS]->Size());
+      }
+  // Delete images:
+  for (int i = 0; i < NUMOSDIMAGEVARIANTS; i++)
+      delete images[i];
+  // Draw images:
+  for (int i = 0; i < NUMOSDIMAGES; i++)
+      Osd->DrawImage(cPoint(rand() % (Osd->Width() + osdImages[i].size.Width()), rand() % (Osd->Height() + osdImages[i].size.Height())).Shifted(-osdImages[i].size.Width(), -osdImages[i].size.Height()), osdImages[i].image);
+  // Drop image references:
+  for (int i = 0; i < NUMOSDIMAGES; i++)
+      cOsdProvider::DropImage(osdImages[i].image);
+  Osd->Flush();
+}
+
 // --- cLineGame -------------------------------------------------------------
 
 class cLineGame : public cOsdObject {
@@ -210,7 +256,7 @@
   if (Pixmap) {
      Pixmap->Clear();
      Pixmap->SetAlpha(0);
-     Pixmap->DrawText(cPoint(0, 0), s, ColorFg, ColorBg, Font);
+     Pixmap->DrawText(cPoint(0, 0), s, ColorFg, ColorBg, Font, w);
      }
   return Pixmap;
 }
@@ -427,16 +473,20 @@
                        const int Size = SmlFont->Width(Text) + 10;
                        const int NumDots = 12;
                        const int AnimFrames = NumDots;
+                       int Rows = min(osd->MaxPixmapSize().Height() / Size, AnimFrames);
+                       int Cols = (AnimFrames + Rows - 1) / Rows;
                        // Temporarily using pixmap layer 0 to have the text alpha blended:
-                       AnimPixmap = osd->CreatePixmap(0, cRect((osd->Width() - Size) / 2, StartLine, Size, Size), cRect(0, 0, Size, Size * AnimFrames));
+                       AnimPixmap = osd->CreatePixmap(0, cRect((osd->Width() - Size) / 2, StartLine, Size, Size), cRect(0, 0, Size * Cols, Size * Rows));
                        if (AnimPixmap) {
                           AnimPixmap->SetAlpha(0);
                           AnimPixmap->Clear();
                           const int Diameter = Size / 5;
-                          int xc = Size / 2 - Diameter / 2;
                           for (int Frame = 0; Frame < AnimFrames; Frame++) {
-                              AnimPixmap->DrawEllipse(cRect(0, Frame * Size, Size, Size), 0xDDFFFFFF);
-                              int yc = Frame * Size + Size / 2 - Diameter / 2;
+                              int x0 = Frame / Rows * Size;
+                              int y0 = Frame % Rows * Size;
+                              AnimPixmap->DrawEllipse(cRect(x0, y0, Size, Size), 0xDDFFFFFF);
+                              int xc = x0 + Size / 2 - Diameter / 2;
+                              int yc = y0 + Size / 2 - Diameter / 2;
                               int Color = 0xFF;
                               int Delta = Color / NumDots / 3;
                               for (int a = 0; a < NumDots; a++) {
@@ -446,7 +496,7 @@
                                   AnimPixmap->DrawEllipse(cRect(x, y, Diameter, Diameter), ArgbToColor(0xFF, Color, Color, Color));
                                   Color -= Delta;
                                   }
-                              AnimPixmap->DrawText(cPoint(0, Frame * Size), Text, clrBlack, clrTransparent, SmlFont, Size, Size, taCenter);
+                              AnimPixmap->DrawText(cPoint(x0, y0), Text, clrBlack, clrTransparent, SmlFont, Size, Size, taCenter);
                               }
                           AnimPixmap->SetLayer(3); // now setting the actual pixmap layer
                           FadeInPixmap = AnimPixmap;
@@ -536,6 +586,10 @@
                      SetArea();
                      DrawSlopes(osd);
                      break;
+       case k3:      Cancel(3);
+                     SetArea();
+                     DrawImages(osd);
+                     break;
        case kBack:
        case kOk:     return osEnd;
        default: return state;
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/HISTORY vdr-2.3.1/PLUGINS/src/pictures/HISTORY
--- vdr-2.2.0/PLUGINS/src/pictures/HISTORY	2015-02-17 14:47:08.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/pictures/HISTORY	2015-07-23 12:15:35.000000000 +0200
@@ -99,3 +99,7 @@
 2015-02-19: Version 2.2.0
 
 - Official release.
+
+2015-07.23: Version 2.3.1
+
+- Added a missing 'const'.
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/Makefile vdr-2.3.1/PLUGINS/src/pictures/Makefile
--- vdr-2.2.0/PLUGINS/src/pictures/Makefile	2014-01-01 14:29:54.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/pictures/Makefile	2014-01-01 14:29:54.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 3.1 2014/01/01 13:29:54 kls Exp $
+# $Id: Makefile 4.0 2014/01/01 13:29:54 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/entry.c vdr-2.3.1/PLUGINS/src/pictures/entry.c
--- vdr-2.2.0/PLUGINS/src/pictures/entry.c	2012-02-17 15:00:28.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/pictures/entry.c	2012-02-17 15:00:28.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: entry.c 3.0 2012/02/17 14:00:28 kls Exp $
+ * $Id: entry.c 4.0 2012/02/17 14:00:28 kls Exp $
  */
 
 #include "entry.h"
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/entry.h vdr-2.3.1/PLUGINS/src/pictures/entry.h
--- vdr-2.2.0/PLUGINS/src/pictures/entry.h	2008-01-06 13:30:50.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/pictures/entry.h	2008-01-06 13:30:50.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: entry.h 3.0 2008/01/06 12:30:50 kls Exp $
+ * $Id: entry.h 4.0 2008/01/06 12:30:50 kls Exp $
  */
 
 #ifndef _ENTRY_H
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/menu.c vdr-2.3.1/PLUGINS/src/pictures/menu.c
--- vdr-2.2.0/PLUGINS/src/pictures/menu.c	2008-01-13 12:35:18.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/pictures/menu.c	2015-07-23 12:13:56.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: menu.c 3.0 2008/01/13 11:35:18 kls Exp $
+ * $Id: menu.c 4.1 2015/07/23 10:13:56 kls Exp $
  */
 
 #include "menu.h"
@@ -85,7 +85,7 @@
   if (Item) {
      const cList<cPictureEntry> *l = pictureEntry->Entries();
      if (l) {
-        cPictureEntry *pe = l->Get(Current());
+        const cPictureEntry *pe = l->Get(Current());
         if (pe) {
            if (SlideShow) {
               cControl::Launch(new cPictureControl(pictures, pe, true));
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/menu.h vdr-2.3.1/PLUGINS/src/pictures/menu.h
--- vdr-2.2.0/PLUGINS/src/pictures/menu.h	2008-01-12 12:22:52.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/pictures/menu.h	2008-01-12 12:22:52.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: menu.h 3.0 2008/01/12 11:22:52 kls Exp $
+ * $Id: menu.h 4.0 2008/01/12 11:22:52 kls Exp $
  */
 
 #ifndef _MENU_H
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/pic2mpg vdr-2.3.1/PLUGINS/src/pictures/pic2mpg
--- vdr-2.2.0/PLUGINS/src/pictures/pic2mpg	2013-07-01 10:33:38.000000000 +0200
+++ vdr-2.3.1/PLUGINS/src/pictures/pic2mpg	2013-07-01 10:33:38.000000000 +0200
@@ -7,7 +7,7 @@
 #
 # See the README file for copyright information and how to reach the author.
 #
-# $Id: pic2mpg 3.1 2013/07/01 08:33:38 kls Exp $
+# $Id: pic2mpg 4.0 2013/07/01 08:33:38 kls Exp $
 
 use File::Path;
 use File::Spec;
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/pictures.c vdr-2.3.1/PLUGINS/src/pictures/pictures.c
--- vdr-2.2.0/PLUGINS/src/pictures/pictures.c	2015-02-17 14:12:50.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/pictures/pictures.c	2015-07-23 12:14:22.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: pictures.c 3.2 2015/02/17 13:12:50 kls Exp $
+ * $Id: pictures.c 4.1 2015/07/23 10:14:22 kls Exp $
  */
 
 #include <getopt.h>
@@ -11,7 +11,7 @@
 #include "menu.h"
 #include "player.h"
 
-static const char *VERSION       = "2.2.0";
+static const char *VERSION       = "2.3.1";
 static const char *DESCRIPTION   = trNOOP("A simple picture viewer");
 static const char *MAINMENUENTRY = trNOOP("Pictures");
 
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/player.c vdr-2.3.1/PLUGINS/src/pictures/player.c
--- vdr-2.2.0/PLUGINS/src/pictures/player.c	2014-02-08 13:48:12.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/pictures/player.c	2014-02-08 13:48:12.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: player.c 3.1 2014/02/08 12:48:12 kls Exp $
+ * $Id: player.c 4.0 2014/02/08 12:48:12 kls Exp $
  */
 
 #include "player.h"
diff -ruN vdr-2.2.0/PLUGINS/src/pictures/player.h vdr-2.3.1/PLUGINS/src/pictures/player.h
--- vdr-2.2.0/PLUGINS/src/pictures/player.h	2012-04-28 13:56:01.000000000 +0200
+++ vdr-2.3.1/PLUGINS/src/pictures/player.h	2012-04-28 13:56:01.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: player.h 3.0 2012/04/28 11:56:01 kls Exp $
+ * $Id: player.h 4.0 2012/04/28 11:56:01 kls Exp $
  */
 
 #ifndef _PLAYER_H
diff -ruN vdr-2.2.0/PLUGINS/src/servicedemo/Makefile vdr-2.3.1/PLUGINS/src/servicedemo/Makefile
--- vdr-2.2.0/PLUGINS/src/servicedemo/Makefile	2014-01-01 14:29:54.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/servicedemo/Makefile	2014-01-01 14:29:54.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 3.1 2014/01/01 13:29:54 kls Exp $
+# $Id: Makefile 4.0 2014/01/01 13:29:54 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
diff -ruN vdr-2.2.0/PLUGINS/src/servicedemo/svccli.c vdr-2.3.1/PLUGINS/src/servicedemo/svccli.c
--- vdr-2.2.0/PLUGINS/src/servicedemo/svccli.c	2015-02-17 14:13:05.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/servicedemo/svccli.c	2015-02-17 14:13:05.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: svccli.c 3.2 2015/02/17 13:13:05 kls Exp $
+ * $Id: svccli.c 4.0 2015/02/17 13:13:05 kls Exp $
  */
 
 #include <stdlib.h>
diff -ruN vdr-2.2.0/PLUGINS/src/servicedemo/svcsvr.c vdr-2.3.1/PLUGINS/src/servicedemo/svcsvr.c
--- vdr-2.2.0/PLUGINS/src/servicedemo/svcsvr.c	2015-02-17 14:13:09.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/servicedemo/svcsvr.c	2015-02-17 14:13:09.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: svcsvr.c 3.2 2015/02/17 13:13:09 kls Exp $
+ * $Id: svcsvr.c 4.0 2015/02/17 13:13:09 kls Exp $
  */
 
 #include <stdlib.h>
diff -ruN vdr-2.2.0/PLUGINS/src/skincurses/Makefile vdr-2.3.1/PLUGINS/src/skincurses/Makefile
--- vdr-2.2.0/PLUGINS/src/skincurses/Makefile	2014-01-01 14:29:54.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/skincurses/Makefile	2014-01-01 14:29:54.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 3.1 2014/01/01 13:29:54 kls Exp $
+# $Id: Makefile 4.0 2014/01/01 13:29:54 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
diff -ruN vdr-2.2.0/PLUGINS/src/skincurses/skincurses.c vdr-2.3.1/PLUGINS/src/skincurses/skincurses.c
--- vdr-2.2.0/PLUGINS/src/skincurses/skincurses.c	2015-02-17 14:13:17.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/skincurses/skincurses.c	2015-02-17 14:13:17.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: skincurses.c 3.3 2015/02/17 13:13:17 kls Exp $
+ * $Id: skincurses.c 4.0 2015/02/17 13:13:17 kls Exp $
  */
 
 #include <ncurses.h>
diff -ruN vdr-2.2.0/PLUGINS/src/status/Makefile vdr-2.3.1/PLUGINS/src/status/Makefile
--- vdr-2.2.0/PLUGINS/src/status/Makefile	2014-01-01 14:29:54.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/status/Makefile	2014-01-01 14:29:54.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 3.1 2014/01/01 13:29:54 kls Exp $
+# $Id: Makefile 4.0 2014/01/01 13:29:54 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
diff -ruN vdr-2.2.0/PLUGINS/src/status/status.c vdr-2.3.1/PLUGINS/src/status/status.c
--- vdr-2.2.0/PLUGINS/src/status/status.c	2015-02-17 14:13:21.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/status/status.c	2015-02-17 14:13:21.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: status.c 3.2 2015/02/17 13:13:21 kls Exp $
+ * $Id: status.c 4.0 2015/02/17 13:13:21 kls Exp $
  */
 
 #include <vdr/plugin.h>
diff -ruN vdr-2.2.0/PLUGINS/src/svdrpdemo/Makefile vdr-2.3.1/PLUGINS/src/svdrpdemo/Makefile
--- vdr-2.2.0/PLUGINS/src/svdrpdemo/Makefile	2014-01-01 14:29:54.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/svdrpdemo/Makefile	2014-01-01 14:29:54.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 3.1 2014/01/01 13:29:54 kls Exp $
+# $Id: Makefile 4.0 2014/01/01 13:29:54 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
diff -ruN vdr-2.2.0/PLUGINS/src/svdrpdemo/svdrpdemo.c vdr-2.3.1/PLUGINS/src/svdrpdemo/svdrpdemo.c
--- vdr-2.2.0/PLUGINS/src/svdrpdemo/svdrpdemo.c	2015-02-17 14:13:29.000000000 +0100
+++ vdr-2.3.1/PLUGINS/src/svdrpdemo/svdrpdemo.c	2015-02-17 14:13:29.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: svdrpdemo.c 3.2 2015/02/17 13:13:29 kls Exp $
+ * $Id: svdrpdemo.c 4.0 2015/02/17 13:13:29 kls Exp $
  */
 
 #include <vdr/plugin.h>
diff -ruN vdr-2.2.0/README vdr-2.3.1/README
--- vdr-2.2.0/README	2013-03-11 14:24:12.000000000 +0100
+++ vdr-2.3.1/README	2015-03-12 11:24:42.000000000 +0100
@@ -32,6 +32,10 @@
 the ones in this system, but here we have the full source code
 and can modify the menus in whatever way desired.
 
+If you actually use VDR, please add yourself to the "VDR User Counter"
+at http://www.tvdr.de/counter.htm. You can also like VDR on facebook
+at https://www.facebook.com/VideoDiskRecorder.
+
 
 "VDR Video Disk Recorder" is a registered trademark of Klaus Schmidinger.
 "TVDR TV Done Right" is a registered trademark of Klaus Schmidinger.
diff -ruN vdr-2.2.0/args.c vdr-2.3.1/args.c
--- vdr-2.2.0/args.c	2014-04-14 14:02:38.000000000 +0200
+++ vdr-2.3.1/args.c	2014-04-14 14:02:38.000000000 +0200
@@ -6,7 +6,7 @@
  *
  * Original version written by Lars Hanisch <dvb@flensrocker.de>.
  *
- * $Id: args.c 1.1 2014/04/14 12:02:38 kls Exp $
+ * $Id: args.c 4.0 2014/04/14 12:02:38 kls Exp $
  */
 
 #include "args.h"
diff -ruN vdr-2.2.0/args.h vdr-2.3.1/args.h
--- vdr-2.2.0/args.h	2014-04-14 13:54:21.000000000 +0200
+++ vdr-2.3.1/args.h	2014-04-14 13:54:21.000000000 +0200
@@ -6,7 +6,7 @@
  *
  * Original version written by Lars Hanisch <dvb@flensrocker.de>.
  *
- * $Id: args.h 1.1 2014/04/14 11:54:21 kls Exp $
+ * $Id: args.h 4.0 2014/04/14 11:54:21 kls Exp $
  */
 
 #ifndef __ARGS_H
diff -ruN vdr-2.2.0/audio.c vdr-2.3.1/audio.c
--- vdr-2.2.0/audio.c	2010-05-16 15:30:11.000000000 +0200
+++ vdr-2.3.1/audio.c	2010-05-16 15:30:11.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: audio.c 3.0 2010/05/16 13:30:11 kls Exp $
+ * $Id: audio.c 4.0 2010/05/16 13:30:11 kls Exp $
  */
 
 #include "audio.h"
diff -ruN vdr-2.2.0/audio.h vdr-2.3.1/audio.h
--- vdr-2.2.0/audio.h	2008-07-06 13:39:21.000000000 +0200
+++ vdr-2.3.1/audio.h	2008-07-06 13:39:21.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: audio.h 3.0 2008/07/06 11:39:21 kls Exp $
+ * $Id: audio.h 4.0 2008/07/06 11:39:21 kls Exp $
  */
 
 #ifndef __AUDIO_H
